X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/b275dcd327e9d85121d20e684911177a36ec490c..8b65736401eb7cc9d7a64067f3a5487e395aeb38:/scripts/rstrip.sh?ds=sidebyside

diff --git a/scripts/rstrip.sh b/scripts/rstrip.sh
index d9d3ad21b..e42caa53a 100755
--- a/scripts/rstrip.sh
+++ b/scripts/rstrip.sh
@@ -1,4 +1,28 @@
-#!/bin/sh
+#!/usr/bin/env bash
+# 
+# Copyright (C) 2006 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+find_modparams() {
+	FILE="$1"
+	$NM "$FILE" | awk '
+BEGIN {
+	FS=" "
+}
+($3 ~ /^__module_parm_/) && ($3 !~ /^__module_parm_desc/) {
+	gsub(/__module_parm_/, "", $3)
+	printf "-K " $3 " "
+}
+($2 ~ /r/) && ($3 ~ /__param_/) {
+	gsub(/__param_/, "", $3)
+	printf "-K " $3 " "
+}
+'
+}
+
 
 SELF=${0##*/}
 
@@ -16,11 +40,19 @@ TARGETS=$*
 }
 
 find $TARGETS -type f -a -exec file {} \; | \
-  sed -n -e 's/^\(.*\):.*ELF.*\(executable\|relocatable\|shared object\).*, not stripped/\1:\2/p' | \
+  sed -n -e 's/^\(.*\):.*ELF.*\(executable\|relocatable\|shared object\).*,.* stripped/\1:\2/p' | \
 (
   IFS=":"
   while read F S; do
     echo "$SELF: $F:$S"
-    eval "$STRIP $F"
+	[ "${S}" = "relocatable" ] && {
+		eval "$STRIP_KMOD -w -K '__param*' -K '__mod*' $(find_modparams "$F")$F"
+	} || {
+		b=$(stat -c '%a' $F)
+		eval "$STRIP $F"
+		a=$(stat -c '%a' $F)
+		[ "$a" = "$b" ] || chmod $b $F
+	}
   done
+  true
 )